/*________________________________________

S Q L   D A T A B A S E   D E M O   P A R T   2
Using ADO Objects in Code
Ron Kessler
Created 12/21/2016

_________________________________________
Purpose: This demo shows how to use ADO objects in C++/CLI.
Since the wizards do not do this for us in this version, you must do so in code.
NOTE: This project requires a SQL database that is running on the local machine.
1.	Use Server Explorer to create a new database called 'MyContactsCS131'.
		a.	Rt. Click on Data Connections in View | Server Explorer
		b.	Choose Create new SQL database
		c.	In the Server box use .\SQLEXPRESS
		d.	Select Windows Authentication
		e.	Enter the name of the new database, click OK

2.	Now expand the database in Server Explorer and Rt. Click on Tables and choose Add Table
		a.	In the Table designer add your fields like I showed in the video and in class.
		b.	Be sure to set your primary key and identity specification
		c.	In the bottom pane (where the script is) change Table to Contacts		
3.	Add fields: First, Last, Address, City, State, Zip
		a.	When you have added all the fields, click the button 'Update' to save changes.
		b.	Now, refresh the Server Explorer pane and rt.click on the table you created.
		c.	Choose Show data and add some people in the table.

4.	Save all 

5.	Add a Datagridview control to your form and in the smart tag, choose Dock.

6. Menus:	Add a menustrip control to the form and create a File menu with Save, Delete,
	and Exit options. Name each menu item: mnuSave, mnuDelete, mnuExit

Look at the pdf screen shots in the images folder of this project to see what mine
looks like.





*/
#pragma once

namespace WindowsApplication1 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	// Add this so we can access ADO objects
	using namespace System::Data::SqlClient;


	public ref class frmMain : public System::Windows::Forms::Form
	{
	public:
		frmMain(void)
		{
			InitializeComponent();
			this->CenterToScreen ();
			
			//--adjust the grid look
			this->dataGridView1->BackgroundColor = Color::BurlyWood;
			this->dataGridView1->ColumnHeadersDefaultCellStyle->Alignment = DataGridViewContentAlignment::MiddleCenter;
		  
		}
#pragma region Windows Form Designer generated code
	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~frmMain()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::DataGridView^  dataGridView1;
	protected:
	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
		private: System::Windows::Forms::ToolStripMenuItem^  mnuSave;
		private: System::Windows::Forms::ToolStripMenuItem^  mnuDelete;


	private: System::Windows::Forms::ToolStripSeparator^  toolStripMenuItem2;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripMenuItem1;
		private: System::Windows::Forms::ToolStripMenuItem^  mnuExit;


	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;


		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			System::Windows::Forms::DataGridViewCellStyle^  dataGridViewCellStyle1 = ( gcnew System::Windows::Forms::DataGridViewCellStyle () );
			this->dataGridView1 = ( gcnew System::Windows::Forms::DataGridView () );
			this->menuStrip1 = ( gcnew System::Windows::Forms::MenuStrip () );
			this->fileToolStripMenuItem = ( gcnew System::Windows::Forms::ToolStripMenuItem () );
			this->mnuSave = ( gcnew System::Windows::Forms::ToolStripMenuItem () );
			this->mnuDelete = ( gcnew System::Windows::Forms::ToolStripMenuItem () );
			this->toolStripMenuItem2 = ( gcnew System::Windows::Forms::ToolStripSeparator () );
			this->toolStripMenuItem1 = ( gcnew System::Windows::Forms::ToolStripSeparator () );
			this->mnuExit = ( gcnew System::Windows::Forms::ToolStripMenuItem () );
			( cli::safe_cast<System::ComponentModel::ISupportInitialize^>( this->dataGridView1 ) )->BeginInit ();
			this->menuStrip1->SuspendLayout ();
			this->SuspendLayout ();
			// 
			// dataGridView1
			// 
			this->dataGridView1->BackgroundColor = System::Drawing::SystemColors::ControlDark;
			dataGridViewCellStyle1->Alignment = System::Windows::Forms::DataGridViewContentAlignment::MiddleCenter;
			dataGridViewCellStyle1->BackColor = System::Drawing::SystemColors::Control;
			dataGridViewCellStyle1->Font = ( gcnew System::Drawing::Font (L"Microsoft Sans Serif", 7.8F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>( 0 )) );
			dataGridViewCellStyle1->ForeColor = System::Drawing::SystemColors::WindowText;
			dataGridViewCellStyle1->SelectionBackColor = System::Drawing::SystemColors::Highlight;
			dataGridViewCellStyle1->SelectionForeColor = System::Drawing::SystemColors::HighlightText;
			dataGridViewCellStyle1->WrapMode = System::Windows::Forms::DataGridViewTriState::True;
			this->dataGridView1->ColumnHeadersDefaultCellStyle = dataGridViewCellStyle1;
			this->dataGridView1->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridView1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->dataGridView1->Location = System::Drawing::Point (0, 28);
			this->dataGridView1->Name = L"dataGridView1";
			this->dataGridView1->RowTemplate->Height = 24;
			this->dataGridView1->Size = System::Drawing::Size (752, 293);
			this->dataGridView1->TabIndex = 2;
			// 
			// menuStrip1
			// 
			this->menuStrip1->ImageScalingSize = System::Drawing::Size (20, 20);
			this->menuStrip1->Items->AddRange (gcnew cli::array< System::Windows::Forms::ToolStripItem^  > (1) { this->fileToolStripMenuItem });
			this->menuStrip1->Location = System::Drawing::Point (0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size (752, 28);
			this->menuStrip1->TabIndex = 3;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// fileToolStripMenuItem
			// 
			this->fileToolStripMenuItem->DropDownItems->AddRange (gcnew cli::array< System::Windows::Forms::ToolStripItem^  > (5)
				{
				this->mnuSave,
					this->mnuDelete, this->toolStripMenuItem2, this->toolStripMenuItem1, this->mnuExit
				});
			this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
			this->fileToolStripMenuItem->Size = System::Drawing::Size (44, 24);
			this->fileToolStripMenuItem->Text = L"File";
			// 
			// mnuSave
			// 
			this->mnuSave->Name = L"mnuSave";
			this->mnuSave->ShortcutKeys = static_cast<System::Windows::Forms::Keys>( ( System::Windows::Forms::Keys::Control | System::Windows::Forms::Keys::S ) );
			this->mnuSave->Size = System::Drawing::Size (181, 26);
			this->mnuSave->Text = L"Save";
			this->mnuSave->Click += gcnew System::EventHandler (this, &frmMain::mnuSave_Click);
			// 
			// mnuDelete
			// 
			this->mnuDelete->Name = L"mnuDelete";
			this->mnuDelete->ShortcutKeys = static_cast<System::Windows::Forms::Keys>( ( System::Windows::Forms::Keys::Control | System::Windows::Forms::Keys::D ) );
			this->mnuDelete->Size = System::Drawing::Size (181, 26);
			this->mnuDelete->Text = L"Delete";
			this->mnuDelete->Click += gcnew System::EventHandler (this, &frmMain::mnuDelete_Click);
			// 
			// toolStripMenuItem2
			// 
			this->toolStripMenuItem2->Name = L"toolStripMenuItem2";
			this->toolStripMenuItem2->Size = System::Drawing::Size (178, 6);
			// 
			// toolStripMenuItem1
			// 
			this->toolStripMenuItem1->Name = L"toolStripMenuItem1";
			this->toolStripMenuItem1->Size = System::Drawing::Size (178, 6);
			// 
			// mnuExit
			// 
			this->mnuExit->Name = L"mnuExit";
			this->mnuExit->ShortcutKeys = static_cast<System::Windows::Forms::Keys>( ( System::Windows::Forms::Keys::Control | System::Windows::Forms::Keys::X ) );
			this->mnuExit->Size = System::Drawing::Size (181, 26);
			this->mnuExit->Text = L"Exit";
			this->mnuExit->Click += gcnew System::EventHandler (this, &frmMain::mnuExit_Click);
			// 
			// frmMain
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF (8, 16);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size (752, 321);
			this->Controls->Add (this->dataGridView1);
			this->Controls->Add (this->menuStrip1);
			this->Margin = System::Windows::Forms::Padding (4);
			this->Name = L"frmMain";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"SQL Databases Part 2: ADO in Code (C++/CLI Version)";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler (this, &frmMain::frmMain_FormClosing);
			this->Load += gcnew System::EventHandler (this, &frmMain::frmMain_Load);
			( cli::safe_cast<System::ComponentModel::ISupportInitialize^>( this->dataGridView1 ) )->EndInit ();
			this->menuStrip1->ResumeLayout (false);
			this->menuStrip1->PerformLayout ();
			this->ResumeLayout (false);
			this->PerformLayout ();

			}
#pragma endregion

		//*********START OF MY CODE***********

	
		
		String^ MSG_TITLE = "Laguna Cycle Works";		//messagebox title

		//---now create our ADO objects 
		
		//---STEP 1 :LOCAL CONNECTION STRING (the dot "." means current machine. We use SQL Express in VStudio
		String^ connectionString = "Data Source =.\\SQLEXPRESS;Initial Catalog=MyContactsCS131;Integrated Security=True";

		//---STEP 2: CONNECTION OBJECT(uses the connString)
		SqlConnection^ connection = gcnew SqlConnection (connectionString);

		//---STEP 3 MAKE SQL STRING(to define which records to get and sort them)
		String^ queryString = "SELECT * FROM Contacts ORDER BY Last";

		//---STEP 4 DATA ADAPTER (uses our SQL and Conn)
		SqlDataAdapter^ adapter = gcnew SqlDataAdapter (queryString, connection);

		//---STEP 5  DATASET(give the dataSet a name that relates to the data you want to display)
		DataSet^ myDS = gcnew DataSet ();


	private: System::Void frmMain_Load (System::Object^  sender, System::EventArgs^  e) 
	{
		//---set up the grid for editing
		dataGridView1->EditMode = DataGridViewEditMode::EditOnEnter;

		//---now fill the grid
		GetMyData ();
		
	}

#pragma region ReadDB

		private:void GetMyData ()
			 {
				
			try
				{
					
					//---STEP 6 FILL THE DATA ADAPTER
					myDS->Clear ();					//no duplicates
					adapter->Fill (myDS, "Contacts");

					//---STEP 7 SET DATAGRID PROPERTIES
					dataGridView1->DataSource = myDS;
					dataGridView1->DataMember = "Contacts";

					
				}
			catch (SqlException^ ex)
				{
					
					NotifyUser ("Error connecting to the database: " + ex->Message + "\n");
				
				}
			finally
				{
					//---always close
					connection->Close ();
				}

			 }

#pragma endregion

#pragma region Handle menu choices

	private: System::Void mnuSave_Click (System::Object^  sender, System::EventArgs^  e)
		{
			try
				{	
					//---you must move to a different record to make the DS accept changes then it updates just fine
					this->BindingContext [myDS, "Contacts"]->Position = 0;

					//the commandbuilder creates Inert/Update/Delete commands for us!
					SqlCommandBuilder^ cmd = gcnew SqlCommandBuilder (adapter);

					adapter->TableMappings->Clear (); //must do this or it tries to add my table twice
					adapter->TableMappings->Add ("Table", "Contacts"); //tell the DA we are adding a Table called contacts so it knows where to look
					adapter->Update (myDS, "Contacts"); //make it so

					NotifyUser ("Your data has been updated.");

					GetMyData ();		//refresh
				}
			catch (Exception^ ex)
				{
				}

		}
		private: System::Void mnuDelete_Click (System::Object^  sender, System::EventArgs^  e)
			{
						
					try
						{
							//---we need the actual value from the Id column for the selected row to know which
							//		record to delete. Rows and Columns are collections!
							String^ selectedCustID = dataGridView1->CurrentRow->Cells ["Id"]->Value->ToString ();

							if (Convert::ToInt32 (selectedCustID) >= 1)
								{
									//---make a SQL command string and command object 
									String^ SQLDelete = "DELETE FROM Contacts WHERE Id = " + selectedCustID;
									SqlCommand^ myCommand = gcnew SqlCommand (SQLDelete, connection);
									String^ myPrompt = "Are you sure you want to delete customer # " + selectedCustID + " ?";

									if (AreYouSure (myPrompt))
										{
										connection->Open ();				//now whack it
										myCommand->ExecuteNonQuery ();
										connection->Close ();
										GetMyData ();											//refresh the dataset and the grid
										NotifyUser ("That customer record has been deleted and the database is updated.");

										}
								}
						}
					catch (Exception^ ex)
						{
						NotifyUser ("There was an error while deleting this record. Make sure to select a valid record. " + ex->Message);
						}
					finally
						{
						connection->Close ();
						}
						
			}
			private: System::Void mnuExit_Click (System::Object^  sender, System::EventArgs^  e)
				{
					this->Close ();
				}

#pragma endregion

#pragma region Handle Notifications For this class


			public: void NotifyUser (String^ msg)
				{

				MessageBox::Show (msg, MSG_TITLE, MessageBoxButtons::OK, MessageBoxIcon::Information);
				}

#pragma endregion

#pragma region ConfirmMsgBox()

			public: bool AreYouSure (String^ msg)
				{
				if (MessageBox::Show (msg, MSG_TITLE, MessageBoxButtons::YesNo,
					MessageBoxIcon::Question, MessageBoxDefaultButton::Button2) == System::Windows::Forms::DialogResult::Yes)
					return true;
				else
					return false;

				}

			private: System::Void frmMain_FormClosing (System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e)
				{
				//---confirm delete no matter how they exit!
				if (!AreYouSure ("Ready to Exit"))
					e->Cancel = true;
				}
#pragma endregion

	
};
}
